package allrounder;
import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JProgressBar;
import javax.swing.WindowConstants;


public class ProgressDialog extends JDialog implements Runnable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4412218030477579881L;
	JProgressBar progressBar;
	JLabel progressText;
	boolean bExit = false;

	public ProgressDialog(JFrame parent, String title, String text, boolean modal, int min, int max) {
		super(parent, title, modal);
		this.progressBar = new JProgressBar(min, max);
		this.progressBar.setStringPainted(true);
		this.progressText = new JLabel(text);
		
		double size[][] = {{TableLayoutConstants.FILL},{0.5, 0.5}};
		this.setLayout(new TableLayout(size));
		this.add(this.progressText, "0, 0");
		this.add(this.progressBar, "0, 1");
		this.setSize(300, 100);
		this.setLocationRelativeTo(parent);
		this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		this.doLayout();
	}
	
	public void setText(String text) {
		this.progressText.setText(text);
		// funzt irgendwie nicht..
		if (this.getSize().width < this.progressText.getSize().width) {
			this.setSize(this.progressText.getSize().width, this.getSize().height);
		}
	}
	
	public void setValue(int iVal) {
		this.progressBar.setValue(iVal);
	}
	
	public int getValue() {
		return this.progressBar.getValue();
	}
	
	public void setMin(int min) {
		this.progressBar.setMinimum(min);
	}
	
	public void setMax(int max) {
		this.progressBar.setMaximum(max);
	}
	
	public void indeterminate(boolean b) {
		if (b) {
			// bewahrt einen platz f�r den string, ansonsten
			// w�rde es layout-probleme geben
			this.progressBar.setString("");
		} else {
			// setzt den string auf default-handling, also automatische %-Anzeige
			this.progressBar.setString(null);
		}
		this.progressBar.setIndeterminate(b);
	}
	
	public void goAway() {
		this.setVisible(false);
		this.dispose();
	}
	
	public void run() {
		this.setVisible(true);
	}
}
