package allrounder;

import java.awt.event.MouseEvent;

import javax.swing.JList;
import javax.swing.ListModel;

public class ToolTipList extends JList {
	public ToolTipList() {
		super();
	}
	public ToolTipList(ListModel mdl) {
		super(mdl);
	}
	
	// This method is called as the cursor moves within the list.
    @Override
	public String getToolTipText(MouseEvent evt) {
        // Get item index
        int index = locationToIndex(evt.getPoint());
        if (index == -1) return null;

        // Get item
        Object item = getModel().getElementAt(index);

        // Return the tool tip text
        if (item instanceof IdString) {
        	IdString tmp = (IdString)item;
        	if (tmp.getToolTipText() != null && !tmp.getToolTipText().trim().equals("")) {
        		return tmp.getToolTipText();
        	}
        }
        return null;
    }
}
