package allrounder.md5;

import java.io.File;
import java.io.IOException;

import allrounder.logger.Logwriter;

import com.twmacinta.util.MD5;

public class Hasher {
	static private String zero = "000000";
	
	public static String imageToHash(File image) {
		if (!image.exists()) return null;
		// hash for yiffindex is actual hash + first 6 chars of file length
		return fileToHash(image) + getLen(image);
	}
	
	public static String fileToHash (File file) {
		if (!file.exists()) return null;
		return MD5.asHex(fileToByteHash(file));
	}
	
	private static byte[] fileToByteHash(File file) {
		if (!file.exists()) return null;
		byte[] hash = null;
		try {
			hash = MD5.getHash(file);
		} catch (IOException e) {
			e.printStackTrace();
			e.printStackTrace(Logwriter.getInstance().getPrintStream());
		}
		return hash;
	}
	
	private static String getLen(File file) {
		String len = ""+ file.length();
		if (len.length() > 6) {
			return len.substring(0, 6);
		} else if (len.length() < 6) {
			return zero.substring(len.length()) + len;
		}
		return len;
	}
}
